Attribute VB_Name = "DataAcces"
Option Explicit

Private Enum DataSourceStructure
  DSS_ID = 1
  DSS_LEVEL = 2
  DSS_TYPE = 3
  DSS_TEXT_THEME = 4
  DSS_TEXT_SUBJECT = 5
End Enum

Public Function ScanExcel(target As Excel.Worksheet) As Hierarchy
  Set ScanExcel = New Hierarchy
  
  Call CSE_ProgressBar.Init(" ", maxVal:=target.UsedRange.Rows.Count, curVal:=2)
  Call CSE_ProgressBar.ShowModeless
  
  Dim theType As ItemType
  Dim theText$
  Dim nRow&: nRow = 2
  Do While target.Cells(nRow, DSS_LEVEL) <> ""
    theType = TextToType(target.Cells(nRow, DSS_TYPE))
    If theType = IT_ORGAN Or theType = IT_PERSON Or theType = IT_GROUP Then
      theText = target.Cells(nRow, DSS_TEXT_SUBJECT)
    Else
      theText = target.Cells(nRow, DSS_TEXT_THEME)
    End If
    
    If ScanExcel.AddItem(theType, target.Cells(nRow, DSS_LEVEL), theText) Is Nothing Then
      Set ScanExcel = Nothing
      Unload CSE_ProgressBar
      Exit Function
    End If

    Call CSE_ProgressBar.IncrementA
    nRow = nRow + 1
  Loop
  
  Unload CSE_ProgressBar
End Function

' ===========
Private Function TextToType(target$) As ItemType
 Select Case target
    Case SHP_TYPE_PROBLEM: TextToType = IT_PROBLEM
    Case SHP_TYPE_POSITION: TextToType = IT_POSITION
    Case SHP_TYPE_GROUP: TextToType = IT_GROUP
    Case SHP_TYPE_ORGAN: TextToType = IT_ORGAN
    Case SHP_TYPE_PERSON: TextToType = IT_PERSON
  End Select
End Function

