VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} ImportDialog 
   Caption         =   " "
   ClientHeight    =   5115
   ClientLeft      =   120
   ClientTop       =   465
   ClientWidth     =   3525
   OleObjectBlob   =   "ImportDialog.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "ImportDialog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public isCancelled_ As Boolean

Private Sub UserForm_Initialize()
  isCancelled_ = True
End Sub

Private Sub UserForm_Terminate()
  isCancelled_ = True
  Call Me.Hide
End Sub

Public Function Init(pHeightInMM As Double)
  isCancelled_ = True
  TBPrintHeight.Value = CLng(pHeightInMM)
End Function

Public Property Get FileName() As String
  FileName = TBDocument.Text
End Property

Public Function GetProps() As PageProps
  With GetProps
    .addHeader_ = CBTitle.Value
    .multipage_ = CBMultipage.Value
    .height_ = Visio.Application.ConvertResult(TBPrintHeight.Value, visMillimeters, visInches)
    .width_ = Visio.Application.ConvertResult(TBPrintWidth.Value, visMillimeters, visInches)
    .problemHeight_ = Visio.Application.ConvertResult(TBIemHeight.Value, visMillimeters, visInches)
    .frontHeight_ = Visio.Application.ConvertResult(TBFrontHeight.Value, visMillimeters, visInches)
    .leftGap_ = Visio.Application.ConvertResult(TBHorizontalGap.Value, visMillimeters, visInches)
    .columnGap_ = Visio.Application.ConvertResult(TBColumnGap.Value, visMillimeters, visInches)
  End With
End Function

' ==========
Private Sub DocumentBtn_Click()
  Dim sFile$: sFile = UserInteraction.PromptFileFilter( _
                                            sInitialPath:=ThisDocument.Path, _
                                            bNewApplication:=True, _
                                            sDescription:=" Excel", _
                                            sFilter:="*.xlsx;*.xls;*.xlsm")
  If sFile <> vbNullString Then _
    TBDocument.Text = sFile
End Sub

Private Sub CancelBtn_Click()
  isCancelled_ = True
  Call Me.Hide
End Sub

Private Sub OkBtn_Click()
  If FileName = vbNullString Then
    Call UserInteraction.ShowMessage(EM_VALIDATION_FAIL)
    Exit Sub
  End If
  
  isCancelled_ = False
  Call Me.Hide
End Sub
