Attribute VB_Name = "MainImpl"
Option Explicit

Public Function ProcessErrorMessages(expectedErrors As Scripting.Dictionary)
  If Err.Number = 0 Then _
    Exit Function
    
  Unload CSE_ProgressBar
  If Not expectedErrors.Exists(Err.Number) Then _
    Call Err.Raise(Err.Number)
  
  Select Case Err.Number
    Case ERR_XL_INVALID_TYPE: Call UserInteraction.ShowMessage(Err.Number, Err.Source)
  End Select
End Function

Public Function ScanExcel(target As Excel.Worksheet) As CDS_StaticHierarchy
  Dim iData As New CDS_StaticHierarchy
  Dim nPosition As TSubjectType
  Dim iNode As CDS_NodeSH
  Dim nRow&: nRow = EXCEL_FIRST_ROW
  Do While target.Cells(nRow, S_ITEM_LEVEL) <> ""
    Set iNode = iData.PushItem(target.Cells(nRow, S_ITEM_LEVEL))
    If iNode Is Nothing Then _
      Exit Function
    Set iNode.data_ = ExtractPayload(nRow, target)
    
    If iNode.data_.type_ = T_ITEM_SUBJECT_TYPE Then _
      nPosition = TextToSubjectType(iNode.data_.text_)
      
    If iNode.rank_ >= 3 Then _
      iNode.data_.position_ = nPosition
    
    Call CSE_ProgressBar.IncrementA
    nRow = nRow + 1
  Loop
  
  Set ScanExcel = iData
End Function

Public Function CreateShapesFor(ByRef theData As CDS_StaticHierarchy, ByRef dest As Visio.Page) As API_ShapeStorage
  Dim iCreator As New ShapeCreator
  Call iCreator.Init(theData, dest)
  Set CreateShapesFor = iCreator.CreateAllShapes()
End Function

Public Function GetMasterFor(theType As TItem) As Visio.Master
  Select Case theType
  Case T_ITEM_FRONT: Set GetMasterFor = FindMaster(ThisDocument, SHAPE_FRONT)
  Case T_ITEM_PROBLEM: Set GetMasterFor = FindMaster(ThisDocument, SHAPE_PROBLEM)
  Case T_ITEM_SUBJECT_TYPE: Set GetMasterFor = FindMaster(ThisDocument, SHAPE_SUBJECT_TYPE)
  Case T_ITEM_GROUP: Set GetMasterFor = FindMaster(ThisDocument, SHAPE_GROUP)
  Case T_ITEM_ORGAN: Set GetMasterFor = FindMaster(ThisDocument, SHAPE_ORGAN)
  Case T_ITEM_PERSON: Set GetMasterFor = FindMaster(ThisDocument, SHAPE_PERSON)
  End Select
End Function

' =============
Private Function ExtractPayload(nRow&, iSource As Excel.Worksheet) As VisioNode
  Dim nType As TItem: nType = TextToItemType(iSource.Cells(nRow, S_ITEM_TYPE))
  nType = TextToItemType(iSource.Cells(nRow, S_ITEM_TYPE))
  If nType = T_ITEM_UNKNOWN Then _
    Call Err.Raise(ERR_XL_INVALID_TYPE, nRow)
  
  Dim sText$
  If nType = T_ITEM_ORGAN Or nType = T_ITEM_PERSON Or nType = T_ITEM_GROUP Then
    sText = iSource.Cells(nRow, S_ITEM_TEXT_SUBJECT)
  Else
    sText = iSource.Cells(nRow, S_ITEM_TEXT_THEME)
  End If
  
  Dim iPayload As New VisioNode
  Call iPayload.Init(nType, sText)
  Set ExtractPayload = iPayload
End Function

