Attribute VB_Name = "z_UIMessages"
' Messaging module
Option Private Module
Option Explicit

Public Enum MsgCode
  MSG_OK = 0
  
  EM_XL_INVALID_TYPE = ERR_XL_INVALID_TYPE
  EM_VALIDATION_FAIL
  EM_DATA_EMPTY
  EM_INVALID_FILE_FORMAT
    
  IM_GENERATION_OK

 ' QM_CLEAR_BEFORE_READD
End Enum

Private g_UI As API_UserInteraction

Public Function UserInteraction() As API_UserInteraction
  If g_UI Is Nothing Then _
    Set g_UI = New API_UserInteraction
  Set UserInteraction = g_UI
End Function

Public Function SetUserInteraction(newUI As API_UserInteraction)
  Set g_UI = newUI
End Function

Public Function UIShowMessage(theCode As MsgCode, ParamArray params() As Variant)
  Dim unwrapped As Variant: unwrapped = params
  unwrapped = FixForwardedParams(unwrapped)
  
  Select Case theCode
  Case EM_VALIDATION_FAIL
    Call MsgBox("  ", vbExclamation)
  Case EM_DATA_EMPTY
    Call MsgBox("Data is empty", vbExclamation)
  Case EM_INVALID_FILE_FORMAT
    Call MsgBox("Invalid file format", vbExclamation)
  Case EM_XL_INVALID_TYPE
    Call MsgBox(Fmt("      {1}", params), vbExclamation)
    
  Case IM_GENERATION_OK
    Call MsgBox(Fmt("Generation complete" & vbNewLine & _
                    "Elements count: {1}" & vbNewLine & _
                    "Page size: {2} x {3} mm^2", unwrapped), vbInformation)
    
  Case Else
    Call MsgBox("Invalid message code", vbCritical)
  End Select
End Function

Public Function UIAskQuestion(theCode As MsgCode, ParamArray params() As Variant) As Boolean
  Dim unwrapped As Variant: unwrapped = params
  unwrapped = FixForwardedParams(unwrapped)
  
  Dim answer&: answer = vbNo
  Select Case theCode
 ' Case QM_CLEAR_BEFORE_READD
  '  answer = MsgBox("     .      ?", vbYesNo + vbQuestion)
        
  Case Else
    Call MsgBox("Invalid message code", vbCritical)
  End Select
  UIAskQuestion = answer = vbYes
End Function
